# coding: utf-8

"""tesdat is a package to generate testdata.
"""

__author__ = 'crohaco'
__author_email__ = 'crohaco.net@gmail.com'
__version__ = '1.5.1'
__license__ = 'Apache License 2.0'

from .container.list import ListContainer
from .container.dict import DictContainer

try:
    from .container.ordereddict import OrderedDictContainer
except ImportError:
    pass

from .model.list import ListModel
from .model.dict import DictModel

from .pattern.choice import ChoicePattern
from .pattern.pickout import PickoutPattern
from .pattern.cycle import CyclePattern
from .pattern.hash import HashPattern
from .pattern.increment import IncrementPattern
from .pattern.sequence import SequencePattern

from .exceptions import Break

LimitedChoicePattern = PickoutPattern
IncPattern = IncrementPattern
SeqPattern = SequencePattern


# Container is ListContainer
Container = ListContainer


def Model(params):  # NOQA
    """
    :param params: structure of the object to be repeated. <list> or <dict>
    :return: model instance.
    """
    if isinstance(params, dict):
        return DictModel(params)
    elif isinstance(params, list):
        return ListModel(params)


def set_json_indent(indent=4):
    """
    :param indent:
    :return:
    """
    from .container import base
    base.json_indent = indent


def add_json_encoder(typ, encoder):
    """
    set function to encode for json.
    :param typ: encode object type. <type>
    :param encoder: encode function. <function>
    :return:
    """
    from .container import base
    base.JSONEncoder.encoder_map[typ] = encoder

try:
    del container, model, pattern, exceptions, log
except NameError:
    pass

