# coding: utf-8


class BaseException(Exception):
    pass


class OutputFileAlreadyExists(BaseException):
    message = 'path already exists. Try: rewrite=True'


class Break(BaseException, StopIteration):
    """
    break controller exception
    """
    message = 'detected the end of the loop.'
    
    @classmethod
    def apply(cls, exc):
        if cls == exc:
            raise cls(cls.message)
        if isinstance(exc, cls):
            raise exc
        return exc

